<script setup>
import AppLayout from '@/Layouts/AppLayoutWater.vue';
import Welcome from '@/Jetstream/Welcome.vue';
import Datepicker from '@vuepic/vue-datepicker';
import JetDropdown from '@/Jetstream/Dropdown.vue';
import JetDropdownLink from '@/Jetstream/DropdownLink.vue';
import '@vuepic/vue-datepicker/dist/main.css';
import { startOfDay, endOfDay, subDays, endOfMonth, endOfYear, startOfMonth, startOfYear, subMonths } from 'date-fns';
import { Link } from '@inertiajs/inertia-vue3';
import DK_Button from '@/components/dk_Button.vue';

</script>

<style>
table {
    border-color: transparent !important;
}

.highcharts-button-symbol {
    opacity: 1;
    stroke: #647F8C !important;
}

.dataTables_wrapper {
    margin-bottom: 0.5rem !important;
}

table.dataTable thead th,
table.dataTable thead td {
    padding: 5px 10px;
    font-size: 0.9rem !important;
    border-bottom: 1px solid rgba(200, 200, 200, 0.75) !important;
}

.dataTables_wrapper .dataTables_paginate .paginate_button.disabled,
.dataTables_wrapper .dataTables_paginate .paginate_button.disabled:hover,
.dataTables_wrapper .dataTables_paginate .paginate_button.disabled:active {
    cursor: default;
    color: rgba(200, 200, 200, 0.9) !important;
    border: 1px solid transparent;
    background: transparent;
    box-shadow: none;
}

.dataTables_wrapper .dataTables_paginate .paginate_button {
    box-sizing: border-box;
    display: inline-block;
    min-width: 1.5em;
    padding: 0.5em 1em;
    margin-left: 2px;
    text-align: center;
    text-decoration: none !important;
    cursor: pointer;
    cursor: hand;
    color: rgba(200, 200, 200, 0.9) !important;
    border: 0;
    border-radius: 0.375rem;
}

.dataTables_wrapper .dataTables_paginate .paginate_button:hover {
    color: rgba(200, 200, 200, 1) !important;
    background-color: rgba(0, 152, 219, 0.1) !important;
    background-image: unset !important;
    border: 0;
}

.dataTables_wrapper .dataTables_paginate .paginate_button.current,
.dataTables_wrapper .dataTables_paginate .paginate_button.current:hover {
    color: rgba(255, 250, 250, 1) !important;
    border: 0 !important;
    background-color: rgba(0, 152, 219, 0.2) !important;
    background-image: unset !important;
    border-bottom-width: 2px;
    border-bottom-color: rgba(255, 250, 250, 1);
    border-radius: 0.375rem;
}

div.dt-buttons {
    float: right;
    margin-bottom: 1rem;
}

.dp__theme_light {
    --dp-background-color: rgba(0, 57, 93, 0.95);
    --dp-text-color: #e3e3e3;
    --dp-hover-color: rgba(0, 255, 255, 0.2);
    --dp-hover-text-color: #FFFAFA;
    --dp-hover-icon-color: #e3e3e3;
    --dp-primary-color: rgba(0, 255, 255, 0.5);
    --dp-primary-text-color: #FFFAFA;
    --dp-secondary-color: #959595;
    --dp-border-color: #FFFAFA;
    --dp-menu-border-color: #FFFAFA;
    --dp-border-color-hover: #FFFAFA;
    --dp-disabled-color: #959595;
    --dp-scroll-bar-background: #f3f3f3;
    --dp-scroll-bar-color: #959595;
    --dp-success-color: rgba(5, 255, 243, 0.7);
    --dp-success-color-disabled: rgba(5, 255, 243, 0.7);
    --dp-icon-color: #e3e3e3;
    --dp-danger-color: #e6002e;
    --dp-highlight-color: rgba(25, 118, 210, 0.1);
}

.dp__preset_range {
    color: #e3e3e3;
}

.dp__action {
    font-weight: 400;
    font-size: x-large;
}

.dp__button {
    background: none;
}

.dp__action_row {
    border-radius: 0.5rem;
    background: none;
    padding-top: 0;
    display: flex;
    justify-content: flex-end;
}

.dp__menu_index {
    border-radius: 0.5rem;
}

.dp__cancel {
    display: none;
    color: #e6002e;
}

.dp__selection_preview {
    display: none;
}

.dp__input_reg {
    background: none;
    border-width: 1px;
    border-color: rgba(200, 200, 200, 0.9);
    border-radius: 0.5rem;

}

.dp__input {
    font-size: 0.95rem;
}

.dp__pointer {
    padding-top: 0.25rem;
    padding-bottom: 0.25rem;
}

.dp__arrow_top {
    display: none;
}
</style>
    
<template>
    <AppLayout title="Daydata">
        <div style="height: calc(100vh - 4.75rem);" class="bg-darkblue-background -z-1 overflow-y-scroll select-none">
            <!-- TIME INTERVAL SELECTOR -->
            <!--<div class="mx-4 text-xs text-center text-gray-light flex justify-between">
                <div class="flex flex-col justify-start items-start w-full">
                    <div class="justify-between self-center flex w-full">
                        <div class="flex items-start">
                            <p class="text-2xl mt-auto">{{ this.name }}&nbsp;(Id:&nbsp;{{ this.id }})</p>
                            <i class="fa-solid fa-circle-info self-center ml-2" @mouseleave="hover_info = false"
                                @mouseover="hover_info = true"></i>         
                            <div v-if="hover_info == true"
                                class="flex justify-center items-center px-2 py-1 gap-x-4 rounded-md border border-gray-light ml-2">
                                <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base">
                                    <p :style="{ 'background-color': this.Service_color }" class="service-label">
                                        {{ this.Service_tag }}
                                    </p>
                                </div>
                                <div class="inline-flex gap-x-2">
                                    <div v-for="(data_s, index_s) in this.Sector" :key="index_s" class="inline-flex">
                                        <div v-for="(data_g, index_g) in this.data.device.group_sector" :key="index_g"
                                            class="inline-flex rounded-md  text-white-snow font-light text-base">
                                            <p v-if="index_s == this.data.device.group_sector[index_g].id" class="sector-label">
                                                {{ data_g.tag }}
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="flex gap-2 items-end mt-0">
                            <div class="flex items-start justify-end">
                                <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('MeterProfile', { id:  this.id })" >                                    
                                    <DK_Button color="blue" :fixedSize="true">
                                        {{ this.$t("general.Profile") }}
                                    </DK_Button>
                                </Link>
                            </div>
                            <div class="flex items-start justify-end">
                                <DK_Button class="pt-6" color="blue" :fixedSize="true" onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit'); window.history.go(-1)">
                                    {{ this.$t("general.Back") }}
                                </DK_Button>
                            </div>
                        </div>
                    </div>
                    <div class="inline-flex justify-center items-end gap-x-4 hidden">
                        <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base">
                            <p :style="{ 'background-color': this.Service_color }" class="service-label">
                                {{ this.Service_tag }}
                            </p>
                        </div>

                        <div class="inline-flex gap-x-2">
                            <div v-for="(data_s, index_s) in this.Sector" :key="index_s" class="inline-flex">
                                <div v-for="(data_g, index_g) in this.group_sector" :key="index_g"
                                    class="inline-flex rounded-md  text-white-snow font-light text-base">
                                    <p v-if="index_s == this.group_sector[index_g].id" class="sector-label">
                                        {{ data_g.tag }}
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mt-4 inline-flex gap-6">

                        <Datepicker id="interval_date" class="w-[21rem] justify-self-end self-end" v-model="date" vertical
                            :presetRanges="this.presetRanges" range minRange="3" @update:modelValue="update"
                            :clearable="false" :format="this.format"></Datepicker>

                        <div class="border border-gray-semilight rounded-lg flex flex-row cursor-pointer">
                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_Readings', { id: this.id })">
                                <div class="time-link rounded-l-lg">
                                    {{ this.$t("general." + "Hour") }}
                                </div>
                            </Link>
                            
                            <div class="time-link-active rounded-r-lg">
                                {{ this.$t("general." + "Day") }}
                            </div>
                        </div>

                    </div>
                    <div v-bind:class="{ 'hidden': this.summary}" class="flex gap-2 whitespace-nowrap items-baseline mt-4">
                        <i class="fa-solid fa-triangle-exclamation" style="font-size:0.8rem; color:rgba(224,191,52,1);"></i>
                        <p class="font-light text-sm text-white-snow flex whitespace-nowrap">
                            {{ this.$t('text.No records were found for the device') }}
                        </p>
                    </div>
                </div>
                
            </div>-->

            <div class="mx-4 text-xs text-center text-gray-light flex justify-between">
                <div class="flex flex-col justify-start items-start w-full">
                    <div class="justify-between self-center items-baseline flex w-full pt-2"> <!--id="routeprofile"-->
                        <div class="flex items-start ">
                            <p class="text-white-snow font-light text-2xl w-full text-left">{{ this.name }}&nbsp;(Id:&nbsp;{{ this.id }})</p>                   
                            <i class="fa-solid fa-circle-info self-center ml-2" @mouseleave="hover_info = false"
                                @mouseover="hover_info = true"></i>         
                            <div v-bind:class="{'invisible' : !hover_info }"
                                class="flex justify-center items-center px-2 py-1 gap-x-4 rounded-md border border-gray-light ml-2">
                                <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base">
                                    <p :style="{ 'background-color': this.Service_color }" class="service-label">
                                        {{ this.Service_tag }}
                                    </p>
                                </div>

                                <!--<p class="text-2xl">&nbsp;/ {{JSON.parse(this.Sector)[0]['name']}}</p>-->
                                <!--<p class="text-2xl">&nbsp;/&nbsp;</p>-->

                                <!--<div v-for="(data, index) in this.Sector" :key="index" class="inline-flex">
                                        <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base	">
                                            <p class="sector-label">
                                                {{data["name"]}}
                                            </p>
                                        </div>
                                    </div>-->
                                <div class="inline-flex gap-x-2">
                                    <div v-for="(data_s, index_s) in this.Sector" :key="index_s" class="inline-flex">
                                        <div v-for="(data_g, index_g) in this.data.device.group_sector" :key="index_g"
                                            class="inline-flex rounded-md  text-white-snow font-light text-base">
                                            <p v-if="index_s == this.data.device.group_sector[index_g].id" class="sector-label">
                                                {{ data_g.tag }}
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="flex gap-2 items-end mt-0">
                            <div class="flex items-start justify-end">
                                <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('meterProfile', { id:  this.id })" >
                                    <DK_Button color="blue" :fixedSize="true">
                                        {{ this.$t("general.Profile") }}
                                    </DK_Button>
                                </Link>
                            </div>
                            <div class="flex items-start justify-end">
                                <DK_Button class="pt-6" color="blue" :fixedSize="true" onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit'); window.history.go(-1)">
                                    {{ this.$t("general.Back") }}
                                </DK_Button>
                            </div>
                        </div>
                        <!--<p v-bind:class='{ "bg-Pressure-TAG": this.Service_name == "pressureLang","bg-Water-quality-TAG": this.Service_name == "waterQualityLang","bg-Deposit-levels-TAG": this.Service_name == "waterLevelLang", "bg-Distribution-TAG": this.Service_name == "distributionLang", "bg-Domiciliary-TAG": this.Service_name == "domiciliaryLang" }' class="rounded-md shadow-lg px-1 text-md">
                                {{this.Service_name.substring(0, 3).toUpperCase()}}
                            </p> -->
                    </div>
                    <div class="inline-flex justify-center items-end gap-x-4 hidden">
                        <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base">
                            <p :style="{ 'background-color': this.Service_color }" class="service-label">
                                {{ this.Service_tag }}
                            </p>
                        </div>

                        <!--<p class="text-2xl">&nbsp;/ {{JSON.parse(this.Sector)[0]['name']}}</p>-->
                        <!--<p class="text-2xl">&nbsp;/&nbsp;</p>-->

                        <!--<div v-for="(data, index) in this.Sector" :key="index" class="inline-flex">
                                <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base	">
                                    <p class="sector-label">
                                        {{data["name"]}}
                                    </p>
                                </div>
                            </div>-->
                        <div class="inline-flex gap-x-2">
                            <div v-for="(data_s, index_s) in this.Sector" :key="index_s" class="inline-flex">
                                <div v-for="(data_g, index_g) in this.data.device.group_sector" :key="index_g"
                                    class="inline-flex rounded-md  text-white-snow font-light text-base">
                                    <p v-if="index_s == this.data.device.group_sector[index_g].id" class="sector-label">
                                        {{ data_g.tag }}
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!--<p id="routeprofile" class="text-xs text-gray-medium font-light">Id: {{this.id}}</p>-->
                    <div class="mt-4 inline-flex gap-6">

                        <Datepicker id="interval_date" class="w-[21rem] justify-self-end self-end" v-model="date" vertical
                            :presetRanges="this.presetRanges" range minRange="3" @update:modelValue="update"
                            :clearable="false" :format="this.format"></Datepicker>

                        <div class="border border-gray-semilight rounded-lg flex flex-row cursor-pointer">
                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_Readings', { id: this.id })">
                                <div class="time-link rounded-l-lg">
                                    {{ this.$t("general." + "Hour") }}
                                </div>
                            </Link>
                            
                            <div class="time-link-active rounded-r-lg">
                                {{ this.$t("general." + "Day") }}
                            </div>
                        </div>

                    </div>

                    <div v-bind:class="{ 'hidden': this.register_length !=0}" class="flex gap-2 whitespace-nowrap items-baseline mt-4">
                        <i class="fa-solid fa-triangle-exclamation" style="font-size:0.8rem; color:rgba(224,191,52,1);"></i>
                        <p class="font-light text-sm text-white-snow flex whitespace-nowrap">
                            {{ this.$t('text.No records were found for the device') }}
                        </p>
                    </div>
                </div>
            </div>

            <div class="grid 2xl:grid-cols-8 grid-cols-6 gap-x-6 px-4">

                <div class="2xl:col-span-7 col-span-5 grid grid-cols-8 gap-6 mt-6 h-[25rem] baltoro-container">

                    <!-- CONSUMPTION & NIGHT CONSUMTION CHART -->
                    <div class="col-span-8 px-10 pt-4">
                        <p class="text-white-snow font-light text-2xl mb-4">{{ this.$t("text." + "Daily consumption summaries") }}
                        </p>
                        <div class="h-[22rem] cursor-crosshair pb-4" id='consumptionchart'></div>
                    </div>

                </div>

                <!-- CONSUMPTION SIDEMENU -->

                <div class="col-span-1 grid content-between text-center text-white-snow text-xs mt-6">

                    <div class="m-0 p-0 baltoro-container py-1">
                        <p class="text-cyan-text font-normal py-1">{{ this.$t("water." + "nightConsuptionLang") }}</p>
                        <div class="w-full inline-flex justify-center items-end">
                            <p class="text-3xl font-sevensegment">
                                {{ this.night_avg }}
                            </p>
                            <p class="pb-1"> &nbsp;m³</p>
                        </div>
                    </div>

                    <div class="m-0 gap-2 grid text-center baltoro-container py-1">

                        <p class="col-span-2 text-cyan-text font-normal py-1">{{ this.$t("water." + "consumptionLang") }}</p>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.daily_max }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.daily_cons_avg }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.daily_min }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                    </div>

                    <div class="m-0 gap-2 grid text-center baltoro-container py-1">

                        <p class="col-span-2 text-cyan-text font-normal py-1">
                            {{ this.$t("water." + "consumptionDispersionLang") }}</p>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Q3") }} </p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.Q3 }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Med") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.Q2 }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Q1") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.Q1 }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="2xl:col-span-7 col-span-5 grid grid-cols-8 gap-6 baltoro-container h-[25rem] mt-6">

                    <!-- Consumption resume & Consumption resume VARIATIONS CHART -->
                    <div class="col-span-8 px-10 pt-4">
                        <p class="text-white-snow font-light text-2xl mb-4">{{ this.$t("water." + "consStatsLang") }}</p>
                        <div class="h-[22rem] cursor-crosshair pb-4" id='resumecons'></div>
                    </div>

                </div>
                <!-- Consumption resume SIDEMENU -->
                <div class="col-span-1 grid content-between text-center text-white-snow text-xs  mt-6">

                    <div class="m-0 p-0 baltoro-container py-1">
                        <p class="text-cyan-text font-normal py-1">{{ this.$t("water." + "consIntervalLang") }}</p>
                        <div class="w-full inline-flex justify-center items-end">
                            <p class="text-3xl font-sevensegment">
                                {{ this.daily_cons }}
                            </p>
                            <p class="pb-1"> &nbsp;m³</p>
                        </div>
                    </div>

                    <div class="m-0 gap-2 grid text-center baltoro-container py-1">

                        <p class="col-span-2 text-cyan-text font-normal py-1">{{ this.$t("water." + "consumptionDataLang") }}
                        </p>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.cons_max }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.cons_avg }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.cons_min }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                    </div>

                    <div class="m-0 gap-2 grid text-center baltoro-container rounded-md py-1">

                        <p class="col-span-2 text-cyan-text font-normal py-1">{{ this.$t("water." + "flowDataLang") }}</p>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ (parseFloat(this.cons_max) / 4).toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³/h</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ (parseFloat(this.cons_avg) / 4).toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³/h</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ (parseFloat(this.cons_min) / 4).toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³/h</p>
                            </div>
                        </div>

                    </div>

                </div>

                <div class="2xl:col-span-8 col-span-6 pt-5 mb-6 px-10 baltoro-container mt-6 ">
                    <p class="text-white-snow font-light text-2xl">{{ this.$t("text." + "Detailed summaries") }}</p>
                    <table id="basicTable" class="row-border">
                        <thead class="bg-transparent text-gray-light">
                            <tr>
                                <th>{{ this.$t("general." + "Date") }}</th>
                                <th>{{ this.$t("general." + "Avg") }} (m3)</th>
                                <th>{{ this.$t("general." + "Max") }} (m3)</th>
                                <th>{{ this.$t("general." + "Min") }} (m3)</th>
                                <th>{{ this.$t("water." + "consumptionLang") }} (m3)</th>
                                <th>{{ this.$t("water." + "nightConsuptionLang") }} (m3)</th>

                            </tr>
                        </thead>
                        <tbody class="text-center">

                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </AppLayout>
</template>

<script>
export default {
    props: ['data', 'user'],

    data() {
        return {

            register_length: (this.data.flow_summary) ? this.data.flow_summary.length : 0, 
            Back: localStorage.getItem("Back"),
            Highcharts: require('highcharts'),
            name: this.data.device.name,
            Service_name: this.data.device.Service,
            Service_color: this.data.device.Service_color,
            Service_tag: this.data.device.Service_tag,
            Sector: this.data.device.Sector,
            id: this.data.device.id,
            group_sector: this.data.device.group_sector,

            night_avg: this.data.device.night_avg,
            daily_max: this.data.device.daily_max,
            daily_cons_avg: this.data.device.daily_cons_avg,
            daily_min: this.data.device.daily_min,
            Q3: this.data.device.Q3,
            Q2: this.data.device.Q2,
            Q1: this.data.device.Q1,
            daily_cons: this.data.device.daily_cons,
            cons_max: this.data.device.cons_max,
            cons_avg: this.data.device.cons_avg,
            cons_min: this.data.device.cons_min,

            summary: (this.data.flow_summary.length != 0 ||this.data.pressure_summary.length != 0) ? true: false,
            
            date: null,
            xdate: new Array(this.data.flow_summary.length),
            day_cons: new Array(this.data.flow_summary.length),
            night_cons: new Array(this.data.flow_summary.length),
            min_max: new Array(this.data.flow_summary.length),
            avg: new Array(this.data.flow_summary.length),
            hover_info: false,
            presetRanges: [
                { label: this.$t("general." + "Last 7 Days"), range: [new Date().setDate(new Date().getDate() - 7), new Date().setDate(new Date().getDate())] },
                { label: this.$t("general." + "Last 14 Days"), range: [new Date().setDate(new Date().getDate() - 14), new Date().setDate(new Date().getDate())] },
                { label: this.$t("general." + "Last 30 Days"), range: [new Date().setDate(new Date().getDate() - 30), new Date().setDate(new Date().getDate())] },
                { label: this.$t("general." + "This month"), range: [startOfMonth(new Date()), new Date()] },
                { label: this.$t("general." + "Last month"), range: [startOfMonth(subMonths(new Date(), 1)), endOfMonth(subMonths(new Date(), 1))] }
            ],
            getData_summary_day_water: (end_date, start_date) => {

                var end_event = new Date(end_date + this.user.timezone_offset * 1000 * 60 * 60); //+ this.user.timezone_offset * 1000 * 60 * 60 + new Date().getTimezoneOffset() * 60 * 1000

                end_event.setDate(end_event.getDate());
                end_event.setMonth(end_event.getMonth());
                //end_event.setHours(end_event.getHours());

                var MM = end_event.getMonth() + 1;
                var dd = end_event.getDate();
                var hh = end_event.getHours();
                var mm = end_event.getMinutes();
                var ss = end_event.getSeconds();

                if (MM.toString().length == 1) MM = '0' + MM;
                if (dd.toString().length == 1) dd = '0' + dd;
                if (hh.toString().length == 1) hh = '0' + hh;
                if (mm.toString().length == 1) mm = '0' + mm;
                if (ss.toString().length == 1) ss = '0' + ss;

                const end_date_format = end_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

                var start_event = new Date(start_date + this.user.timezone_offset * 1000 * 60 * 60);

                start_event.setDate(start_event.getDate());
                start_event.setMonth(start_event.getMonth());
                //start_event.setHours(start_event.getHours());

                var MM = start_event.getMonth() + 1;
                var dd = start_event.getDate();
                var hh = start_event.getHours();
                var mm = start_event.getMinutes();
                var ss = start_event.getSeconds();

                if (MM.toString().length == 1) MM = '0' + MM;
                if (dd.toString().length == 1) dd = '0' + dd;
                if (hh.toString().length == 1) hh = '0' + hh;
                if (mm.toString().length == 1) mm = '0' + mm;
                if (ss.toString().length == 1) ss = '0' + ss;

                const start_date_format = start_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

                ///* FLAG BUS_iddevice */
                let BUS_iddevice = this.id + '_2';

                window.emitter.emit('changeLoaderStatus', true, 'orbit')
                
                return axios({
                    method: 'get',
                    url: window.location.origin + '/api/gateway/data_summary_day_water/' + this.user.id + '/' + this.id + '/' + BUS_iddevice + '/' + start_date_format + '/' + end_date_format,
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                        'Authorization': 'Bearer ' + this.user.token
                    },
                })
                    .then((response) => {
                        window.emitter.emit('changeLoaderStatus', false, 'orbit')
                        return response;
                    })
                    .catch((error) => {
                        window.emitter.emit('changeLoaderStatus', false, 'orbit')

                        if(error.response && error.response.status && error.response.status == 429){
                            window.alert( this.$t('text.Api attempts'));
                        }else{
                            return "Failed!", error;
                        }

                    });
            },
        }
    },

    beforeCreate: function () {
        this.$i18n.locale = this.user.language
    },

    mounted() {
        window.emitter.emit('changeLoaderStatus', false, 'orbit')

        require('highcharts/modules/exporting')(this.Highcharts);
        require('highcharts/highcharts-more')(this.Highcharts);

        const Highcharts = this.Highcharts;

        this.date = [
            new Date((this.data.flow_summary[0].date_local)),
            new Date((this.data.flow_summary[this.data.flow_summary.length - 1].date_local))
        ];

        for (var index = 0; index < this.data.flow_summary.length; index++) {
            this.xdate[index] = (new Date((this.data.flow_summary[this.data.flow_summary.length - index - 1].date_local + ' GMT'))).getTime();

            this.day_cons[index] = [
                this.xdate[index],
                parseFloat(parseFloat(this.data.flow_summary[this.data.flow_summary.length - index - 1].value_day).toFixed(3))
            ];
            this.night_cons[index] = [
                this.xdate[index],
                parseFloat(parseFloat(this.data.flow_summary[this.data.flow_summary.length - index - 1].value_night).toFixed(3))
            ];
            this.min_max[index] = [
                this.xdate[index],
                parseFloat(parseFloat(this.data.flow_summary[this.data.flow_summary.length - index - 1].value_min).toFixed(3)),
                parseFloat(parseFloat(this.data.flow_summary[this.data.flow_summary.length - index - 1].value_max).toFixed(3))
            ];
            this.avg[index] = [
                this.xdate[index],
                parseFloat(parseFloat(this.data.flow_summary[this.data.flow_summary.length - index - 1].value_avg).toFixed(3))
            ];
        }

        this.topChart = {
            chart: {
                zoomType: 'x',
                backgroundColor: 'transparent',
                spacingTop: 20,
                animation: {
                    duration: 150
                },
                resetZoomButton: {
                    position: {
                        align: 'left',
                        verticalAlign: 'top',
                        x: 0,
                        y: 2.5
                    },
                    theme: {
                        r: 5.6,
                    }
                }
            },
            accessibility: {
                enabled: false
            },
            title: {
                text: ''
            },
            xAxis: {
                lineColor: '#647F8C',
                visible: true,
                labels: {
                    style: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.7,
                    }
                },
                type: "datetime",
                dateTimeLabelFormats: {
                    day: '%m-%d',
                    week: '%m-%d',
                    month: '%Y-%m',
                    year: '%Y'
                }
            },
            yAxis: [{
                gridLineColor: '#647F8C',
                title: {
                    text: ''
                },
                labels: {
                    formatter: function () {
                        return this.pos + ' m³'
                    },
                    style: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.7,
                    }
                },
                visible: true,
            }],
            exporting: {
                enabled: false
            },
            credits: {
                enabled: false
            },
            legend: {
                enabled: true,
                itemStyle: {
                    color: 'rgba(200, 200, 200, 0.9)',
                    opacity: 0.75,
                    fontWeight: 'light'
                },
                itemHoverStyle: {
                    color: 'rgba(200, 200, 200, 0.9)',
                    opacity: 1,
                    fontWeight: 'light'
                }
            },
            plotOptions: {
                column: {
                    pointPlacement: 'on',
                    pointPadding: 0.4,
                    borderWidth: 0,
                    grouping: false,
                    shadow: false,
                }
            },
            tooltip: {
                //headerFormat: '<p style="font-size:12px; line-height: 12px; color:#b8bec0">{point.key} </p><br/>',
                //xDateFormat: '%Y-%m-%d  %H:%M:%S',
                shared: true,
                split: false,
                //backgroundColor: 'rgba(7,82,103,0.95)',
                backgroundColor: 'rgba(7,82,103,0.95)',
                borderRadius: 12,
                borderWidth: 1,
                borderColor: 'rgba(250, 250, 250, 0.65)',
                padding: 6,
                formatter: function () {
                    var date = new Date(this.x);

                    var day = date.getDate();
                    var month = date.getMonth() + 1;
                    var year = date.getFullYear();

                    if (month.toString().length == 1) month = '0' + month;
                    if (day.toString().length == 1) day = '0' + day;

                    var tempx = `${year}/${month}/${day}`;
                    var s = '<b>' + '<p style="font-size:12px; line-height: 12px; font-weight: 300; color:rgba(250, 250, 250, 0.95)">' + tempx + '</p><br/>';
                    $.each(this.points, function () {
                        s += '<p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.series.name + ' </p><p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.y.toFixed(3) +
                            ' ' + this.series.userOptions.tooltip.valueSuffix + '</p><br/>';
                    });


                    return s;
                },
            },
        };

        this.topChart.series = [{
            name: this.$t("general." + "Day"),
            type: 'column',
            data: this.day_cons,
            color: "#05fff3",
            pointPlacement: -0.2,
            marker: {
                enabled: false,
            },
            tooltip: {
                valueSuffix: 'm³'
            },
        }, {
            name: this.$t("general." + "Night"),
            type: 'column',
            data: this.night_cons,
            color: "#23A7BE",
            marker: {
                enabled: false,
            },
            tooltip: {
                valueSuffix: 'm³'
            },
        }];

        this.Highcharts.chart('consumptionchart', this.topChart);

        ////

        this.centralChart = {
            chart: {
                zoomType: 'x',
                backgroundColor: 'transparent',
                spacingTop: 20,
                animation: {
                    duration: 150
                },
                resetZoomButton: {
                    position: {
                        align: 'left',
                        verticalAlign: 'top',
                        x: 0,
                        y: 2.5
                    },
                    theme: {
                        r: 5.6,
                    },
                }
            },
            accessibility: {
                enabled: false
            },
            title: {
                text: ''
            },
            xAxis: {
                lineColor: '#647F8C',
                visible: true,
                labels: {
                    style: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.7,
                    }
                },
                type: "datetime",
                dateTimeLabelFormats: {
                    day: '%m-%d',
                    week: '%m-%d',
                    month: '%Y-%m',
                    year: '%Y'
                }
            },
            yAxis: [{
                gridLineColor: '#647F8C',
                id: 0,
                title: {
                    text: ''
                },
                labels: {
                    formatter: function () {
                        return this.pos + '  ' + this.chart.userOptions.series[0].tooltip.valueSuffix
                    },
                    style: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.7,
                    }
                },
                visible: true,
            }],
            exporting: {
                enabled: false
            },
            credits: {
                enabled: false
            },
            legend: {
                enabled: true,
                itemStyle: {
                    color: 'rgba(200, 200, 200, 0.9)',
                    opacity: 0.75,
                    fontWeight: 'light'
                },
                itemHoverStyle: {
                    color: 'rgba(200, 200, 200, 0.9)',
                    opacity: 1,
                    fontWeight: 'light'
                }
            },
            tooltip: {
                //headerFormat: '<p style="font-size:12px; line-height: 12px; color:#b8bec0">{point.key} </p><br/>',
                //xDateFormat: '%Y-%m-%d  %H:%M:%S',
                shared: true,
                split: false,
                backgroundColor: 'rgba(7,82,103,0.95)',
                borderRadius: 12,
                borderWidth: 1,
                borderColor: 'rgba(250, 250, 250, 0.65)',
                padding: 6,
                formatter: function () {

                    var date = new Date(this.x);

                    var day = date.getDate();
                    var month = date.getMonth() + 1;
                    var year = date.getFullYear();

                    if (month.toString().length == 1) month = '0' + month;
                    if (day.toString().length == 1) day = '0' + day;

                    var tempx = `${year}/${month}/${day}`;
                    var s = '<b>' + '<p style="font-size:12px; line-height: 12px; font-weight: 300; color:rgba(250, 250, 250, 0.95)">' + tempx + '</p><br/>';
                    $.each(this.points, function (k, y) {
                        if (this.series.name == 'Limit values') {
                            s += '<p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.series.name + ' </p><p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + y.point.low + ' → ' + y.point.high +
                                ' ' + this.series.userOptions.tooltip.valueSuffix + '</p><br/>';
                        } else {
                            s += '<p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.series.name + ' </p><p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.y.toFixed(3) +
                                ' ' + this.series.userOptions.tooltip.valueSuffix + '</p><br/>';
                        }
                    });


                    return s;
                },
            },
        };

        this.centralChart.series = [{
            name: this.$t("general." + "Limit values"),
            type: 'areasplinerange',
            data: this.min_max,
            color: "#05fff3",
            lineWidth: 0,
            opacity: 0.75,
            marker: {
                enabled: false
            },
            tooltip: {
                valueSuffix: 'm³'
            }
        }, {
            name: this.$t("general." + "Avg"),
            type: 'spline',
            visible: true,
            data: this.avg,
            color: "#FF29D9",
            lineWidth: 1.5,
            marker: {
                enabled: false
            },
            tooltip: {
                valueSuffix: 'm³'
            }
        }];

        this.Highcharts.chart('resumecons', this.centralChart);

        const export_title = this.name + '_' + this.id + '_' + this.date

        this.table = $('#basicTable').DataTable({
            language: {
                url: '/assets/i18n/' + this.user.language + '.json'
            },
            order: [[0, "desc"]],
            dom: '<"row"<"col-sm-6"B><"col-sm-6">>t<"row"<"col-sm-6"i><"col-sm-6"p>><"clear">',
            ordering: true,
            pageLength: 10,
            buttons: [
                {
                    extend: 'csv',
                    text: 'CSV',
                    title: export_title,
                    className: 'btn btn-brand',
                    exportOptions: {
                        columns: ':visible'
                    }
                },
                {
                    extend: 'excel',
                    text: 'Excel',
                    title: export_title,
                    className: 'btn btn-brand',
                    exportOptions: {
                        columns: ':visible'
                    }
                },
                {
                    extend: 'print',
                    text: this.$t("general." + "Print"),
                    title: export_title,
                    className: 'btn btn-brand',
                    exportOptions: {
                        columns: ':visible'
                    }
                },
            ]
        });

        for (var index = 0; index < this.data.flow_summary.length; index++) {
            this.table.row.add([
                '<td>' + this.data.flow_summary[this.data.flow_summary.length - 1 - index].date_local.substring(0, 10) + '</td>',
                '<td>' + this.data.flow_summary[this.data.flow_summary.length - 1 - index].value_avg + '</td>',
                '<td>' + this.data.flow_summary[this.data.flow_summary.length - 1 - index].value_max + '</td>',
                '<td>' + this.data.flow_summary[this.data.flow_summary.length - 1 - index].value_min + '</td>',
                '<td>' + this.data.flow_summary[this.data.flow_summary.length - 1 - index].value_day + '</td>',
                '<td>' + this.data.flow_summary[this.data.flow_summary.length - 1 - index].value_night + '</td>',
            ]).draw(false);
        };
    },

    methods: {
        
        getRandomInt(min, max) {
            return Math.floor(Math.random() * (max - min)) + min;
        },
        format() {
            var date = this.date;
            var to = this.$t("general." + "To")

            var day1 = date[0].getDate();
            var month1 = date[0].getMonth() + 1;
            var year1 = date[0].getFullYear();
            var hour1 = date[0].getHours();
            var min1 = date[0].getMinutes();

            if (month1.toString().length == 1) month1 = '0' + month1;
            if (day1.toString().length == 1) day1 = '0' + day1;
            if (hour1.toString().length == 1) hour1 = '0' + hour1;
            if (min1.toString().length == 1) min1 = '0' + min1;

            var day2 = date[1].getDate();
            var month2 = date[1].getMonth() + 1;
            var year2 = date[1].getFullYear();
            var hour2 = date[1].getHours();
            var min2 = date[1].getMinutes();

            if (month2.toString().length == 1) month2 = '0' + month2;
            if (day2.toString().length == 1) day2 = '0' + day2;
            if (hour2.toString().length == 1) hour2 = '0' + hour2;
            if (min2.toString().length == 1) min2 = '0' + min2;

            return `${year1}/${month1}/${day1} ${hour1}:${min1} ${to} ${year2}/${month2}/${day2} ${hour2}:${min2}`;
        },
        update(modelData) {

            

            var start_date = new Date((modelData[0]));
            start_date = start_date.getTime() - this.user.timezone_offset * 1000 * 60 * 60;

            var end_date = new Date((modelData[1]));
            end_date = end_date.getTime() - this.user.timezone_offset * 1000 * 60 * 60;

            if (start_date > new Date()) {
                start_date = new Date();
                start_date.setDate(start_date.getDate());
            }

            if (end_date > new Date()) {
                end_date = new Date();
            }

            this.getData_summary_day_water(end_date, start_date).then(response => {
                this.summary = (response.data.flow_summary.length != 0 || response.data.pressure_summary.length  != 0) ? true: false,
                this.night_avg = response.data.summary.night_avg;
                this.daily_max = response.data.summary.daily_max;
                this.daily_cons_avg = response.data.summary.daily_cons_avg;
                this.daily_min = response.data.summary.daily_min;
                this.Q3 = response.data.summary.Q3;
                this.Q2 = response.data.summary.Q2;
                this.Q1 = response.data.summary.Q1;
                this.daily_cons = response.data.summary.daily_cons;
                this.cons_max = response.data.summary.cons_max;
                this.cons_avg = response.data.summary.cons_avg;
                this.cons_min = response.data.summary.cons_min;

                this.date = [
                    new Date((response.data.flow_summary[0].date_local)),
                    new Date((response.data.flow_summary[response.data.flow_summary.length - 1].date_local))
                ];

                this.xdate = new Array(response.data.flow_summary.length);
                this.day_cons = new Array(response.data.flow_summary.length);
                this.night_cons = new Array(response.data.flow_summary.length);
                this.min_max = new Array(response.data.flow_summary.length);
                this.avg = new Array(response.data.flow_summary.length);

                for (var index = 0; index < response.data.flow_summary.length; index++) {
                    this.xdate[index] = (new Date((response.data.flow_summary[response.data.flow_summary.length - index - 1].date_local + ' GMT'))).getTime();

                    this.day_cons[index] = [
                        this.xdate[index],
                        parseFloat(parseFloat(response.data.flow_summary[response.data.flow_summary.length - index - 1].value_day).toFixed(3))
                    ];
                    this.night_cons[index] = [
                        this.xdate[index],
                        parseFloat(parseFloat(response.data.flow_summary[response.data.flow_summary.length - index - 1].value_night).toFixed(3))
                    ];
                    this.min_max[index] = [
                        this.xdate[index],
                        parseFloat(parseFloat(response.data.flow_summary[response.data.flow_summary.length - index - 1].value_min).toFixed(3)),
                        parseFloat(parseFloat(response.data.flow_summary[response.data.flow_summary.length - index - 1].value_max).toFixed(3))
                    ];
                    this.avg[index] = [
                        this.xdate[index],
                        parseFloat(parseFloat(response.data.flow_summary[response.data.flow_summary.length - index - 1].value_avg).toFixed(3))
                    ];
                }

                this.topChart.series = [{
                    name: this.$t("general." + "Day"),
                    type: 'column',
                    data: this.day_cons,
                    color: "#05fff3",
                    pointPlacement: -0.2,
                    marker: {
                        enabled: false,
                    },
                    tooltip: {
                        valueSuffix: 'm³'
                    },
                }, {
                    name: this.$t("general." + "Night"),
                    type: 'column',
                    data: this.night_cons,
                    color: "#23A7BE",
                    marker: {
                        enabled: false,
                    },
                    tooltip: {
                        valueSuffix: 'm³'
                    },
                }];

                this.Highcharts.chart('consumptionchart', this.topChart);

                this.centralChart.series = [{
                    name: this.$t("general." + "Limit values"),
                    type: 'areasplinerange',
                    data: this.min_max,
                    color: "#05fff3",
                    lineWidth: 0,
                    opacity: 0.75,
                    marker: {
                        enabled: false
                    },
                    tooltip: {
                        valueSuffix: 'm³'
                    }
                }, {
                    name: this.$t("general." + "Avg"),
                    type: 'spline',
                    visible: true,
                    data: this.avg,
                    color: "#FF29D9",
                    lineWidth: 1.5,
                    marker: {
                        enabled: false
                    },
                    tooltip: {
                        valueSuffix: 'm³'
                    }
                }];

                this.Highcharts.chart('resumecons', this.centralChart);

                const export_title = this.name + '_' + this.id + '_' + this.date

                this.table.clear();

                for (var index = 0; index < response.data.flow_summary.length; index++) {
                    this.table.row.add([
                        '<td>' + response.data.flow_summary[response.data.flow_summary.length - 1 - index].date_local.substring(0, 10) + '</td>',
                        '<td>' + response.data.flow_summary[response.data.flow_summary.length - 1 - index].value_avg + '</td>',
                        '<td>' + response.data.flow_summary[response.data.flow_summary.length - 1 - index].value_max + '</td>',
                        '<td>' + response.data.flow_summary[response.data.flow_summary.length - 1 - index].value_min + '</td>',
                        '<td>' + response.data.flow_summary[response.data.flow_summary.length - 1 - index].value_day + '</td>',
                        '<td>' + response.data.flow_summary[response.data.flow_summary.length - 1 - index].value_night + '</td>',
                    ]).draw(false);
                };

            })

            var end_event = new Date(end_date);

            end_event = new Date(end_event.getTime() + this.user.timezone_offset * 1000 * 60 * 60 + new Date().getTimezoneOffset() * 60 * 1000);

            end_event.setDate(end_event.getDate());
            end_event.setMonth(end_event.getMonth());
            end_event.setHours(end_event.getHours());

            var MM = end_event.getMonth() + 1;
            var dd = end_event.getDate();
            var hh = end_event.getHours();
            var mm = end_event.getMinutes();
            var ss = end_event.getSeconds();

            if (MM.toString().length == 1) MM = '0' + MM;
            if (dd.toString().length == 1) dd = '0' + dd;
            if (hh.toString().length == 1) hh = '0' + hh;
            if (mm.toString().length == 1) mm = '0' + mm;
            if (ss.toString().length == 1) ss = '0' + ss;

            end_date = end_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

            var start_event = new Date(start_date);

            start_event = new Date(start_event.getTime() + this.user.timezone_offset * 1000 * 60 * 60 + new Date().getTimezoneOffset() * 60 * 1000);

            start_event.setDate(start_event.getDate());
            start_event.setMonth(start_event.getMonth());
            start_event.setHours(start_event.getHours());

            var MM = start_event.getMonth() + 1;
            var dd = start_event.getDate();
            var hh = start_event.getHours();
            var mm = start_event.getMinutes();
            var ss = start_event.getSeconds();

            if (MM.toString().length == 1) MM = '0' + MM;
            if (dd.toString().length == 1) dd = '0' + dd;
            if (hh.toString().length == 1) hh = '0' + hh;
            if (mm.toString().length == 1) mm = '0' + mm;
            if (ss.toString().length == 1) ss = '0' + ss;

            start_date = start_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

            const startDate = new Date(start_date + ' GMT');
            const endDate = new Date(end_date + ' GMT');

            this.end_date = endDate;
            this.start_date = startDate;

            this.date = [startDate, endDate];
        },
    },
}    
</script>
    
